<template>
	<view class="bg-image">
		<uni-popup ref="popup" type="dialog">
			<view class="popup-content">
				<view style="margin: 3rpx;">
					<label>是否呼叫以下货架：</label>
				</view>
				<view style="font-size: 52rpx;text-align: center;margin-top: 15rpx;margin-bottom: 10rpx;">
					<text>{{fixedInfo.shelfCode}}</text>
				</view>
				<view class="button-group">
					<button @click="hidePopup">取消</button>
					<button @click="saveData">确认</button>
				</view>
			</view>
		</uni-popup>

		<view class="diy-flex-row">
			<view style="flex: 3">
			</view>
			<view style="flex: 80;margin: 5rpx;">
				<view class="diy-flex-row">
					<view class="rightImageContainer" @click="cameraScanCode" style="flex: 12;padding-top: 20rpx;">
						<image style="width: 60rpx;height: 60rpx" src="/static/scan.png" />
					</view>

					<view class="uni-input-wrapper" style="flex: 60;">
						<input id="inputMatCode" class="uni-input" style="font-size: 50rpx; padding: 10rpx;"
							:placeholder="placeholderText" v-model="matCodeCondition" @blur="queryMatList"></input>
					</view>

					<view style="flex: 3;">
					</view>

					<view style="flex: 30;">
						<button @click="queryMatList(true)">查询</button>
					</view>
				</view>
			</view>
			<view style="flex: 2">
				<!-- 占位 -->
			</view>
		</view>

		<view class="diy-flex-column" style="margin-top: 5rpx;">
			<view class="diy-flex-inforow">

				<view style="width: 10rpx;"></view>

				<view style="width: 275rpx;">记录数:[{{recordCount}}]</view>

				<view style="width: 10rpx;"></view>

				<view style="width: 455rpx;">工位码:{{locationCode}}</view>

			</view>
		</view>

		<view class="diy-flex-column" style="margin-top: 5rpx;">
			<scroll-view class="scroll-view" scroll-y="true">
				<view v-for="(item, index) in cardData" :key="index" @touchstart="cardTouchStart"
					@touchmove="cardTouchMove" @longpress="longpress(item)">
					<Card :item="item" :currentIndex="index" :cardData="cardData" />
				</view>
			</scroll-view>
		</view>


	</view>
</template>

<script>
	import bindSelectMat from '@/pages/bindSelectMat/bindSelectMat.vue';

	import {
		recive
	} from '../../src/libs/Broadcast.js';

	import {
		unregisterReceiver
	} from '../../src/libs/Broadcast.js';

	import {
		getConfig
	} from '@/config.js';

	import {
		saveConfig
	} from '@/config.js';

	import {
		getServerIPAndPort
	} from '@/config.js';

	import Card from '@/components/Card.vue';
	import {
		ref,
		nextTick
	} from 'vue';
	import uniPopup from '@/node_modules/@dcloudio/uni-ui/lib/uni-popup/uni-popup';
	import {
		getCurrentInstance
	} from 'vue';

	export default {
		components: {
			uniPopup,
			Card
		},
		setup() {
			const {
				proxy
			} = getCurrentInstance();
			// 不能修改的信息
			const fixedInfo = {
				shelfId: 0,
				shelfCode: '',
			};
			const popup = ref(null);
			const inputValue = ref('');

			const showPopup = (info) => {
				fixedInfo.shelfId = info.shelfId;
				fixedInfo.shelfCode = info.shelfCode;

				popup.value.open();
			};

			const hidePopup = () => {
				popup.value.close();
			};

			const saveData = () => {
				var serverIPAndPort = getServerIPAndPort();

				//调用接口进行货架的呼叫
				uni.request({
					url: 'http://' + serverIPAndPort +
						'/pdaProductionLineCallIn/callIn', // 请求的接口地址
					method: 'POST', // 设置请求方式为 POST
					data: {
						"locationId": proxy.locationId,
						"locationCode": proxy.locationCode,
						"shelfId": fixedInfo.shelfId,
						"shelfCode": fixedInfo.shelfCode,
						"userName": getConfig('userName', 'admin'),
						"deviceType": "PDA"
					},
					header: {
						'Content-Type': 'application/json', // 如果需要以JSON格式发送数据
					},
					success: (res) => {
						// 请求成功的回调函数
						if (res.statusCode === 200) {
							//接口返回数据为200 表示获取成功！
							if (res.data.code == 200) {
								hidePopup();
								proxy.queryMatList(false);
								uni.showToast({
									title: '呼叫成功!',
									icon: 'none',
									duration: 4000
								});
							} else {
								uni.showToast({
									title: '呼叫失败：' + res.data.message,
									icon: 'none',
									duration: 4000
								});
							}

						} else {
							uni.showToast({
								title: '服务器返回错误状态码' + res.statusCode,
								icon: 'none',
								duration: 2500
							});
						}
					},
					fail: (err) => {
						// 请求失败的回调函数
						uni.showToast({
							title: '请求失败:' + err.errMsg,
							icon: 'none',
							duration: 3000
						});
						this.clear();
					},
					complete: (event) => {
						// 请求完成的回调函数（无论成功或失败都会调用）

					}
				});

			};
			return {
				fixedInfo,
				popup,
				inputValue,
				showPopup,
				hidePopup,
				saveData
			};
		},
		data() {
			return {

				placeholderText: '请先扫描工位码',
				matCodeCondition: '', //物料编码搜索条件
				//工位ID 工位码
				locationId: 0,
				locationCode: '',

				userName: '', //当前登录的用户名 用于调用接口传参

				recordCount: 0, //记录数
				cardData: null, //列表数据

				shelfId: null,
				shelfCode: '',

				//监控滑动的位置
				touchStartX: 0,
				touchStartY: 0,
				isMove: false, //滑动标识 是否滑动
			}
		},
		onShow: function() {
			this.userName = getConfig('userName', 'admin');
			const self = this; // 保存this的引用
			recive(function(res) {
				console.log("Success:" + res.data);
				//此功能只扫描工位码
				self.analysisScanCode(res.data);
			}, function(err) {
				console.log("Error:", JSON.stringify(err)); // 正确打印错误信息
			});
		},
		methods: {
			//摄像头扫码
			cameraScanCode() {
			      uni.scanCode({
			        success: (res) => {
			          console.log('扫码结果:', res.result);
			          this.analysisScanCode(res.result);
			        },
			        fail: (err) => {
			          console.error('扫码失败:', err);
			          // 处理扫码失败的情况
			        }
			      });
			    },
			//扫码获取工位信息
			analysisScanCode: function(encodedString) {
				// 去除末尾的逗号和"..."（如果有的话）
				encodedString = encodedString.replace(/,\s*\.\.\.$/, '');
				this.locationCode = encodedString;
				//调用接口获取当前工位信息 当前工位是否有货架 是否有即将到来的货架
				var serverIPAndPort = getServerIPAndPort();
				uni.request({
					url: 'http://' + serverIPAndPort +
						'/pdaProductionLineCallIn/getLocationInfoForCallIn', // 请求的接口地址
					method: 'POST', // 设置请求方式为 POST
					data: {
						"locationCode": this.locationCode,
						"userName": this.userName,
						"deviceType": "PDA",
					},
					header: {
						'Content-Type': 'application/json', // 如果需要以JSON格式发送数据
					},
					success: (res) => {
						// 请求成功的回调函数
						if (res.statusCode === 200) {
							//接口返回数据为200 表示获取成功！
							if (res.data.code == 200) {
								//未查询到信息
								if (res.data.data == null || res.data.data.count == 0) {
									uni.showToast({
										title: '未获取到该工位相关信息!',
										icon: 'none',
										duration: 1500
									});
									this.clearLocation();
									return;
								}
								//有工位的信息
								this.locationId = res.data.data.locationId;
								this.locationCode = res.data.data.locationCode;
								this.matCodeCondition = '';
								this.placeholderText = '可以输入查询';

								// uni.showToast({
								// 	title: '获取成功!',
								// 	icon: 'none',
								// 	duration: 1000
								// });

							} else {
								uni.showToast({
									title: res.data.message,
									icon: 'none',
									duration: 3500
								});
								this.clearLocation();
							}

						} else {
							uni.showToast({
								title: '服务器返回错误状态码' + res.statusCode,
								icon: 'none',
								duration: 3000
							});
							this.clearLocation();
						}
					},
					fail: (err) => {
						// 请求失败的回调函数
						uni.showToast({
							title: '请求失败:' + err.errMsg,
							icon: 'none',
							duration: 3000
						});

						this.clearLocation();
					},
					complete: (event) => {
						// 请求完成的回调函数（无论成功或失败都会调用）
						console.log('请求完成', event);
					}
				});


			},

			//搜索获取物料信息
			queryMatList: function(isTip) {
				if (this.locationCode == null || this.locationCode == '') {
					if (isTip) {
						uni.showToast({
							title: '请先扫描工位码！',
							icon: 'none',
							duration: 1000
						});
					}
					return;
				}

				if (this.matCodeCondition == this.locationCode) {
					this.matCodeCondition = '';
					return;
				}
				var serverIPAndPort = getServerIPAndPort();
				uni.request({
					url: 'http://' + serverIPAndPort +
						'/pdaProductionLineCallIn/getMatDetailCurrentInfosForCallIn', // 请求的接口地址
					method: 'POST', // 设置请求方式为 POST
					data: {
						"locationId": this.locationId,
						"locationCode": this.locationCode,
						"matCodeCondition": this.matCodeCondition,
						"userName": this.userName,
						"deviceType": "PDA"
					},
					header: {
						'Content-Type': 'application/json', // 如果需要以JSON格式发送数据
					},
					success: (res) => {
						// 请求成功的回调函数
						if (res.statusCode === 200) {
							//接口返回数据为200 表示获取成功！
							if (res.data.code == 200) {
								//未查询到信息
								if (res.data.data == null || res.data.data.count == 0) {
									if (isTip) {
										uni.showToast({
											title: '获取失败!',
											icon: 'none',
											duration: 1500
										});

									}
									this.clear();
									return;
								}
								//有物料信息
								this.cardData = res.data.data.lists;
								this.recordCount = res.data.data.count;
								if (isTip) {
									uni.showToast({
										title: '获取成功!',
										icon: 'none',
										duration: 100
									});
								}

							} else {
								if (isTip) {
									uni.showToast({
										title: '获取失败:' + res.data.message,
										icon: 'none',
										duration: 3500
									});

								}
								this.clear();
							}

						} else {
							if (isTip) {
								uni.showToast({
									title: '服务器返回错误状态码' + res.statusCode,
									icon: 'none',
									duration: 3000
								});
								this.clear();
							}
						}
					},
					fail: (err) => {
						if (isTip) {
							// 请求失败的回调函数
							uni.showToast({
								title: '请求失败:' + err.errMsg,
								icon: 'none',
								duration: 3000
							});
							this.clear();
						}
					},
					complete: (event) => {
						// 请求完成的回调函数（无论成功或失败都会调用）
						console.log('请求完成', event);
					}
				});


			},
			//清空工位码信息
			clearLocation: function() {
				this.placeholderText = '请先扫描工位码';
				this.locationId = 0;
				this.locationCode = '';

				this.cardData = null;
				this.recordCount = 0;
			},
			//清空当前界面所有内容
			clear: function() {
				this.cardData = null;
				this.recordCount = 0;
			},
			//解决长按和滑动冲突的问题
			cardTouchStart(e) {
				this.isMove = false;
				this.touchStartX = e.touches[0].clientX;
				this.touchStartY = e.touches[0].clientY;
			},
			cardTouchMove(e) {
				var deltaX = e.changedTouches[0].clientX - this.touchStartX;
				var deltaY = e.changedTouches[0].clientY - this.touchStartY;
				if (Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) {
					this.isMove = true;
				}
			},
			//长按
			longpress(item) {
				if (this.isMove == false) {
					this.showPopup(item);
				}
			},
		}
	}
</script>

<style>
	.uni-input-wrapper {
		/* #ifndef APP-NVUE */
		display: flex;
		/* #endif */
		flex-direction: row;
		flex-wrap: nowrap;
		background-color: #FFFFFF;
	}

	.mini-btn {
		margin-right: 10rpx;
	}

	.bg-image {
		background-image: url('/static/background.png');
		/* 背景图片路径 */
		background-size: cover;
		/* 背景图片覆盖整个元素 */
		background-position: center;
		/* 背景图片居中 */
		height: 100%;
		/* 视图高度设置为100% */
		width: 100%;
		/* 视图宽度设置为100% */
		position: fixed;
		/* 视图定位为固定 */
		top: 0;
		left: 0;
		/* z-index: -1; */
	}

	.diy-flex-row {
		display: flex;
		flex-direction: row;
		margin-top: 15rpx;
		margin-bottom: 15rpx;
		font-size: 50rpx;
	}

	.diy-flex-column {
		display: flex;
		flex-direction: column;
	}

	.diy-flex-inforow {
		display: flex;
		flex-direction: row;
		font-size: 40rpx;
		font-weight: 500;
		margin-top: 8rpx;
		margin-bottom: 8rpx;
	}

	.scroll-view {
		height: 79vh;
	}

	.popup-content {
		padding: 20px;
		background-color: rgba(0, 0, 0, 1);
		background-color: white;
		z-index: 2;
		border-radius: 20rpx;
	}


	.input-item {
		margin-bottom: 5rpx;
		display: flex;
		align-items: center;
		/* 让内部元素垂直居中 */
	}

	.input-item label {
		display: inline-block;
	}

	.input-item input {
		display: inline-block;
		background: wheat;
		width: 280rpx;
	}

	.button-group {
		display: flex;
		justify-content: space-between;
		margin-top: 20rpx;
	}

	.button-group button {
		margin-top: 20rpx;
		padding: 10rpx 10rpx;
		border: none;
		border-radius: 5px;
		background-color: #007AFF;
		color: #fff;
		cursor: pointer;
	}
</style>